
#!/usr/bin/env python3

# ---------------------------
# projects/collatz/Collatz.py
# Copyright (C)
# Glenn P. Downing
# ---------------------------

#from arr import arr

# ------------
# collatz_read
# ------------

# PRELOADED ARRAY of max cycle lengths between values of 1 and 1000
# generated using python3 script "getmostcycles.py"
range_arr = [(1000, 179), (2000, 182), (3000, 217), (4000, 238), (5000, 215), (6000, 236), (7000, 262), (8000, 252), (9000, 247), (10000, 260), (11000, 268), (12000, 250), (13000, 263), (14000, 276), (15000, 271), (16000, 271), (17000, 266), (18000, 279), (19000, 261), (20000, 274), (21000, 256), (22000, 269), (23000, 269), (24000, 282), (25000, 264), (26000, 264), (27000, 308), (28000, 259), (29000, 259), (30000, 272), (31000, 272), (32000, 285), (33000, 267), (34000, 267), (35000, 311), (36000, 324), (37000, 249), (38000, 306), (39000, 244), (40000, 306), (41000, 288), (42000, 257), (43000, 288), (44000, 270), (45000, 270), (46000, 314), (47000, 283), (48000, 314), (49000, 296), (50000, 296), (51000, 278), (52000, 309), (53000, 340), (54000, 322), (55000, 260), (56000, 260), (57000, 322), (58000, 304), (59000, 273), (60000, 304), (61000, 335), (62000, 317), (63000, 286), (64000, 330), (65000, 299), (66000, 268), (67000, 268), (68000, 312), (69000, 312), (70000, 299), (71000, 312), (72000, 325), (73000, 263), (74000, 294), (75000, 325), (76000, 307), (77000, 307), (78000, 351), (79000, 338), (80000, 307), (81000, 320), (82000, 320), (83000, 320), (84000, 289), (85000, 320), (86000, 302), (87000, 302), (88000, 333), (89000, 333), (90000, 315), (91000, 315), (92000, 333), (93000, 315), (94000, 284), (95000, 315), (96000, 328), (97000, 297), (98000, 297), (99000, 284), (100000, 328), (101000, 341), (102000, 310), (103000, 310), (104000, 248), (105000, 310), (106000, 341), (107000, 354), (108000, 292), (109000, 279), (110000, 310), (111000, 292), (112000, 323), (113000, 323), (114000, 292), (115000, 305), (116000, 349), (117000, 305), (118000, 305), (119000, 336), (120000, 305), (121000, 318), (122000, 336), (123000, 318), (124000, 331), (125000, 287), (126000, 318), (127000, 331), (128000, 287), (129000, 331), (130000, 344), (131000, 331), (132000, 300), (133000, 331), (134000, 313), (135000, 300), (136000, 344), (137000, 313), (138000, 331), (139000, 313), (140000, 313), (141000, 344), (142000, 326), (143000, 375), (144000, 282), (145000, 326), (146000, 295), (147000, 357), (148000, 295), (149000, 326), (150000, 326), (151000, 370), (152000, 295), (153000, 308), (154000, 308), (155000, 352), (156000, 308), (157000, 383), (158000, 339), (159000, 321), (160000, 352), (161000, 370), (162000, 290), (163000, 339), (164000, 321), (165000, 334), (166000, 321), (167000, 352), (168000, 321), (169000, 321), (170000, 334), (171000, 290), (172000, 334), (173000, 303), (174000, 347), (175000, 334), (176000, 272), (177000, 334), (178000, 334), (179000, 347), (180000, 303), (181000, 365), (182000, 316), (183000, 334), (184000, 254), (185000, 316), (186000, 329), (187000, 347), (188000, 329), (189000, 316), (190000, 360), (191000, 329), (192000, 329), (193000, 347), (194000, 329), (195000, 342), (196000, 360), (197000, 298), (198000, 285), (199000, 329), (200000, 329), (201000, 342), (202000, 311), (203000, 342), (204000, 311), (205000, 311), (206000, 355), (207000, 373), (208000, 311), (209000, 311), (210000, 311), (211000, 342), (212000, 355), (213000, 355), (214000, 373), (215000, 293), (216000, 280), (217000, 386), (218000, 324), (219000, 324), (220000, 355), (221000, 324), (222000, 355), (223000, 324), (224000, 324), (225000, 324), (226000, 368), (227000, 368), (228000, 306), (229000, 355), (230000, 306), (231000, 443), (232000, 350), (233000, 337), (234000, 368), (235000, 381), (236000, 306), (237000, 337), (238000, 350), (239000, 306), (240000, 350), (241000, 368), (242000, 275), (243000, 319), (244000, 337), (245000, 275), (246000, 319), (247000, 332), (248000, 350), (249000, 288), (250000, 350), (251000, 332), (252000, 319), (253000, 319), (254000, 332), (255000, 363), (256000, 288), (257000, 332), (258000, 345), (259000, 301), (260000, 345), (261000, 332), (262000, 332), (263000, 301), (264000, 407), (265000, 332), (266000, 332), (267000, 314), (268000, 345), (269000, 270), (270000, 345), (271000, 407), (272000, 283), (273000, 314), (274000, 358), (275000, 332), (276000, 345), (277000, 314), (278000, 389), (279000, 345), (280000, 314), (281000, 345), (282000, 358), (283000, 314), (284000, 358), (285000, 358), (286000, 376), (287000, 314), (288000, 327), (289000, 389), (290000, 345), (291000, 327), (292000, 327), (293000, 340), (294000, 358), (295000, 296), (296000, 358), (297000, 327), (298000, 327), (299000, 371), (300000, 327), (301000, 371), (302000, 296), (303000, 340), (304000, 340), (305000, 340), (306000, 265), (307000, 309), (308000, 309), (309000, 371), (310000, 340), (311000, 371), (312000, 309), (313000, 384), (314000, 340), (315000, 278), (316000, 340), (317000, 353), (318000, 309), (319000, 353), (320000, 322), (321000, 371), (322000, 353), (323000, 309), (324000, 322), (325000, 384), (326000, 340), (327000, 247), (328000, 322), (329000, 291), (330000, 353), (331000, 322), (332000, 291), (333000, 353), (334000, 335), (335000, 322), (336000, 322), (337000, 366), (338000, 366), (339000, 335), (340000, 366), (341000, 304), (342000, 335), (343000, 353), (344000, 335), (345000, 304), (346000, 441), (347000, 348), (348000, 322), (349000, 335), (350000, 366), (351000, 304), (352000, 379), (353000, 335), (354000, 304), (355000, 348), (356000, 379), (357000, 348), (358000, 304), (359000, 379), (360000, 348), (361000, 410), (362000, 348), (363000, 361), (364000, 317), (365000, 317), (366000, 361), (367000, 348), (368000, 286), (369000, 317), (370000, 361), (371000, 392), (372000, 348), (373000, 317), (374000, 348), (375000, 330), (376000, 361), (377000, 423), (378000, 361), (379000, 330), (380000, 361), (381000, 379), (382000, 374), (383000, 361), (384000, 330), (385000, 330), (386000, 348), (387000, 330), (388000, 299), (389000, 330), (390000, 436), (391000, 361), (392000, 330), (393000, 299), (394000, 361), (395000, 405), (396000, 312), (397000, 330), (398000, 330), (399000, 374), (400000, 299), (401000, 374), (402000, 387), (403000, 268), (404000, 343), (405000, 343), (406000, 405), (407000, 361), (408000, 268), (409000, 312), (410000, 312), (411000, 449), (412000, 330), (413000, 343), (414000, 374), (415000, 374), (416000, 312), (417000, 387), (418000, 343), (419000, 343), (420000, 281), (421000, 343), (422000, 325), (423000, 356), (424000, 418), (425000, 356), (426000, 356), (427000, 356), (428000, 374), (429000, 294), (430000, 281), (431000, 312), (432000, 343), (433000, 387), (434000, 343), (435000, 356), (436000, 281), (437000, 325), (438000, 387), (439000, 400), (440000, 356), (441000, 325), (442000, 294), (443000, 356), (444000, 338), (445000, 325), (446000, 338), (447000, 325), (448000, 325), (449000, 369), (450000, 369), (451000, 387), (452000, 307), (453000, 294), (454000, 369), (455000, 338), (456000, 338), (457000, 356), (458000, 338), (459000, 307), (460000, 307), (461000, 307), (462000, 444), (463000, 369), (464000, 325), (465000, 338), (466000, 369), (467000, 369), (468000, 413), (469000, 382), (470000, 338), (471000, 307), (472000, 276), (473000, 338), (474000, 307), (475000, 382), (476000, 320), (477000, 307), (478000, 382), (479000, 351), (480000, 351), (481000, 413), (482000, 382), (483000, 351), (484000, 307), (485000, 320), (486000, 338), (487000, 382), (488000, 382), (489000, 382), (490000, 351), (491000, 320), (492000, 320), (493000, 426), (494000, 395), (495000, 351), (496000, 320), (497000, 320), (498000, 289), (499000, 351), (500000, 395), (501000, 364), (502000, 320), (503000, 426),
             (504000, 320), (505000, 364), (506000, 364), (507000, 382), (508000, 364), (509000, 377), (510000, 364), (511000, 333), (512000, 470), (513000, 333), (514000, 351), (515000, 364), (516000, 395), (517000, 302), (518000, 333), (519000, 439), (520000, 364), (521000, 333), (522000, 364), (523000, 333), (524000, 302), (525000, 364), (526000, 408), (527000, 408), (528000, 377), (529000, 377), (530000, 333), (531000, 346), (532000, 346), (533000, 377), (534000, 377), (535000, 346), (536000, 302), (537000, 333), (538000, 377), (539000, 346), (540000, 346), (541000, 408), (542000, 364), (543000, 346), (544000, 359), (545000, 315), (546000, 346), (547000, 452), (548000, 377), (549000, 333), (550000, 315), (551000, 346), (552000, 377), (553000, 315), (554000, 346), (555000, 421), (556000, 390), (557000, 346), (558000, 315), (559000, 315), (560000, 284), (561000, 359), (562000, 328), (563000, 359), (564000, 328), (565000, 421), (566000, 328), (567000, 359), (568000, 359), (569000, 359), (570000, 359), (571000, 377), (572000, 359), (573000, 372), (574000, 359), (575000, 328), (576000, 346), (577000, 390), (578000, 390), (579000, 346), (580000, 359), (581000, 266), (582000, 328), (583000, 328), (584000, 434), (585000, 372), (586000, 359), (587000, 359), (588000, 328), (589000, 315), (590000, 297), (591000, 359), (592000, 403), (593000, 328), (594000, 328), (595000, 328), (596000, 328), (597000, 372), (598000, 372), (599000, 341), (600000, 372), (601000, 372), (602000, 403), (603000, 297), (604000, 297), (605000, 372), (606000, 341), (607000, 328), (608000, 341), (609000, 403), (610000, 359), (611000, 341), (612000, 354), (613000, 310), (614000, 310), (615000, 310), (616000, 447), (617000, 372), (618000, 372), (619000, 310), (620000, 341), (621000, 372), (622000, 372), (623000, 310), (624000, 354), (625000, 385), (626000, 354), (627000, 509), (628000, 341), (629000, 279), (630000, 279), (631000, 341), (632000, 310), (633000, 385), (634000, 354), (635000, 310), (636000, 416), (637000, 310), (638000, 354), (639000, 354), (640000, 354), (641000, 416), (642000, 372), (643000, 416), (644000, 279), (645000, 279), (646000, 310), (647000, 323), (648000, 341), (649000, 323), (650000, 385), (651000, 341), (652000, 336), (653000, 354), (654000, 385), (655000, 323), (656000, 385), (657000, 429), (658000, 354), (659000, 398), (660000, 354), (661000, 323), (662000, 323), (663000, 292), (664000, 292), (665000, 367), (666000, 442), (667000, 323), (668000, 367), (669000, 323), (670000, 336), (671000, 323), (672000, 323), (673000, 367), (674000, 336), (675000, 367), (676000, 385), (677000, 336), (678000, 336), (679000, 380), (680000, 367), (681000, 336), (682000, 336), (683000, 305), (684000, 380), (685000, 336), (686000, 354), (687000, 398), (688000, 380), (689000, 292), (690000, 336), (691000, 336), (692000, 442), (693000, 323), (694000, 367), (695000, 367), (696000, 336), (697000, 336), (698000, 318), (699000, 367), (700000, 367), (701000, 367), (702000, 411), (703000, 380), (704000, 349), (705000, 504), (706000, 380), (707000, 305), (708000, 349), (709000, 349), (710000, 336), (711000, 380), (712000, 380), (713000, 411), (714000, 380), (715000, 305), (716000, 305), (717000, 380), (718000, 349), (719000, 336), (720000, 349), (721000, 411), (722000, 367), (723000, 411), (724000, 349), (725000, 362), (726000, 305), (727000, 349), (728000, 318), (729000, 362), (730000, 318), (731000, 380), (732000, 336), (733000, 380), (734000, 349), (735000, 349), (736000, 424), (737000, 318), (738000, 380), (739000, 424), (740000, 424), (741000, 393), (742000, 318), (743000, 349), (744000, 318), (745000, 318), (746000, 349), (747000, 287), (748000, 362), (749000, 318), (750000, 393), (751000, 362), (752000, 331), (753000, 318), (754000, 424), (755000, 318), (756000, 362), (757000, 362), (758000, 331), (759000, 362), (760000, 362), (761000, 380), (762000, 362), (763000, 331), (764000, 375), (765000, 362), (766000, 331), (767000, 331), (768000, 468), (769000, 331), (770000, 393), (771000, 349), (772000, 344), (773000, 393), (774000, 362), (775000, 331), (776000, 437), (777000, 331), (778000, 393), (779000, 437), (780000, 362), (781000, 344), (782000, 362), (783000, 331), (784000, 331), (785000, 313), (786000, 375), (787000, 300), (788000, 362), (789000, 406), (790000, 406), (791000, 375), (792000, 344), (793000, 437), (794000, 375), (795000, 331), (796000, 331), (797000, 468), (798000, 344), (799000, 300), (800000, 375), (801000, 375), (802000, 406), (803000, 388), (804000, 300), (805000, 331), (806000, 375), (807000, 344), (808000, 406), (809000, 331), (810000, 344), (811000, 406), (812000, 287), (813000, 362), (814000, 375), (815000, 313), (816000, 357), (817000, 344), (818000, 344), (819000, 450), (820000, 357), (821000, 450), (822000, 375), (823000, 344), (824000, 375), (825000, 326), (826000, 344), (827000, 313), (828000, 419), (829000, 313), (830000, 375), (831000, 344), (832000, 419), (833000, 388), (834000, 357), (835000, 344), (836000, 313), (837000, 344), (838000, 525), (839000, 344), (840000, 388), (841000, 357), (842000, 313), (843000, 388), (844000, 331), (845000, 357), (846000, 401), (847000, 313), (848000, 419), (849000, 313), (850000, 357), (851000, 357), (852000, 357), (853000, 326), (854000, 357), (855000, 419), (856000, 388), (857000, 375), (858000, 357), (859000, 370), (860000, 313), (861000, 357), (862000, 326), (863000, 326), (864000, 344), (865000, 326), (866000, 388), (867000, 326), (868000, 344), (869000, 357), (870000, 388), (871000, 326), (872000, 432), (873000, 326), (874000, 326), (875000, 388), (876000, 432), (877000, 370), (878000, 401), (879000, 326), (880000, 357), (881000, 326), (882000, 326), (883000, 313), (884000, 370), (885000, 295), (886000, 370), (887000, 445), (888000, 401), (889000, 295), (890000, 370), (891000, 339), (892000, 326), (893000, 295), (894000, 326), (895000, 370), (896000, 326), (897000, 370), (898000, 339), (899000, 370), (900000, 295), (901000, 401), (902000, 401), (903000, 383), (904000, 295), (905000, 383), (906000, 295), (907000, 445), (908000, 326), (909000, 370), (910000, 326), (911000, 476), (912000, 383), (913000, 401), (914000, 357), (915000, 370), (916000, 339), (917000, 339), (918000, 383), (919000, 339), (920000, 432), (921000, 339), (922000, 339), (923000, 445), (924000, 308), (925000, 370), (926000, 339), (927000, 370), (928000, 476), (929000, 383), (930000, 339), (931000, 370), (932000, 308), (933000, 370), (934000, 370), (935000, 414), (936000, 414), (937000, 383), (938000, 352), (939000, 445), (940000, 507), (941000, 383), (942000, 339), (943000, 339), (944000, 352), (945000, 383), (946000, 352), (947000, 383), (948000, 383), (949000, 383), (950000, 352), (951000, 414), (952000, 383), (953000, 414), (954000, 414), (955000, 383), (956000, 339), (957000, 352), (958000, 352), (959000, 321), (960000, 352), (961000, 414), (962000, 352), (963000, 383), (964000, 414), (965000, 352), (966000, 321), (967000, 365), (968000, 308), (969000, 321), (970000, 352), (971000, 458), (972000, 352), (973000, 321), (974000, 383), (975000, 383), (976000, 339), (977000, 383), (978000, 334), (979000, 383), (980000, 334), (981000, 427), (982000, 321), (983000, 383), (984000, 383), (985000, 352), (986000, 427), (987000, 352), (988000, 396), (989000, 321), (990000, 352), (991000, 321), (992000, 321), (993000, 352), (994000, 290), (995000, 365), (996000, 365), (997000, 365), (998000, 440), (999000, 396), (1000000, 396)]

# lazy cache for optimizing cycle length computation on runtime
cache = {}


def collatz_read(s):
    """
    read two ints
    s a string
    return a list of two ints, representing the beginning and end of a range, [i, j]
    """
    # handles empty lines
    if s == "\n":
        return "\n"

    # precondition: line has two integers (i and j)
    a = s.split()
    return [int(a[0]), int(a[1])]

# ------------
# collatz_eval
# ------------


def collatz_eval(i, j):
    """
    Better Optimization Solution Approach:

    Initialize hardcoded list of tuples: [(a,x),(b,y),(c,z)]
    a,b,c,... is set of multiples of 1000 starting 1000 ending 1000000
    x,y,z,... is max cycle length of range(n-999, n) for each multiple of 1000

    Use this as an eager cache for breaking up i,j into sub-ranges
    and returning maxes for those ranges

    For brute force computation:
    use dictionary cache to store cycle length values for each n
    to be reused when calculating cycle lengths
    """
    # account for swapped arguments
    if i > j:
        start = j
        end = i
    else:
        start = i
        end = j

    # use helper function for brute force computation optimized using dictionary cache
    if end - start < 1000:
        return collatz_eval_simple(start, end)

    # compute nearest factors of 1000 to start and end (ceiling for start, floor for end)
    thousand1 = start // 1000 * 1000 + 1000
    thousand2 = end // 1000 * 1000

    # break up (i,j) into non-thousand ranges and thousand ranges
    # brute force compute non-thousand ranges
    maxlen = max(collatz_eval_simple(start, thousand1),
                 collatz_eval_simple(thousand2, end))

    # iterate through eager cache and return values for thousand ranges
    for x in range(thousand2, thousand1, -1000):
        maxlen = max(maxlen, range_arr[x//1000-1][1])

    # reduce using max() function to get max cycle length
    return maxlen


# -------------------
# collatz_eval_simple
# -------------------
def collatz_eval_simple(start, end):
    """
    start is beginning of range
    end is end of range

    Simple optimization of eval using lazy dictionary cache
    Compute individual cycle lengths between start and end and store them to the cache
    Call helper function to do the computation and pull from cache in that process
    """
    maxlen = 1
    # brute force calcuate cycle lengths for each value in range
    for n in range(start, end + 1):

        # use helper function to find individual cycle lengths using lazy cache
        temp = collatz_find(n, cache)

        # update lazy cache
        cache[n] = temp

        # update max iteratively
        if temp > maxlen:
            maxlen = temp
    return maxlen

# -------------
# collatz_find
# -------------


def collatz_find(n, cache):
    """
    Compute cycle length of number n

    n is number for which you compute cycle length
    cache is lazy dictionary cache used to speed up computation

    """
    # if n is already at 1, then cycle length has to be 1
    curr = 1

    # keep going until you get to 1
    while n != 1:

        # check if n's cycle length has already been computed
        if n in cache:

            # if it has, add it to the current computation and subtract 1 to not double count current n
            curr += cache[n] - 1
            break

        # otherwise follow the algorithm
        if n % 2 == 0:
            n /= 2
        else:
            n = 3 * n + 1
        curr += 1

    return curr

# -------------
# collatz_print
# -------------


def collatz_print(w, i, j, v):
    """
    print three ints
    w a writer
    i the beginning of the range, inclusive
    j the end       of the range, inclusive
    v the max cycle length
    """
    w.write(str(i) + " " + str(j) + " " + str(v) + "\n")

# -------------
# collatz_solve
# -------------


def collatz_solve(r, w):
    """
    r a reader
    w a writer
    """
    for s in r:
        result = collatz_read(s)
        if result == "\n":
            w.write("\n")
            continue
        else:
            i, j = result
            v = collatz_eval(i, j)
            collatz_print(w, i, j, v)
